from typing import TYPE_CHECKING, Any, Dict, List, Type, TypeVar, Union

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

if TYPE_CHECKING:
    from ..models.column_distinct_count_anomaly_stationary_partition_check_spec import (
        ColumnDistinctCountAnomalyStationaryPartitionCheckSpec,
    )
    from ..models.column_distinct_count_change_1_day_check_spec import (
        ColumnDistinctCountChange1DayCheckSpec,
    )
    from ..models.column_distinct_count_change_7_days_check_spec import (
        ColumnDistinctCountChange7DaysCheckSpec,
    )
    from ..models.column_distinct_count_change_30_days_check_spec import (
        ColumnDistinctCountChange30DaysCheckSpec,
    )
    from ..models.column_distinct_count_change_check_spec import (
        ColumnDistinctCountChangeCheckSpec,
    )
    from ..models.column_distinct_count_check_spec import ColumnDistinctCountCheckSpec
    from ..models.column_distinct_percent_anomaly_stationary_check_spec import (
        ColumnDistinctPercentAnomalyStationaryCheckSpec,
    )
    from ..models.column_distinct_percent_change_1_day_check_spec import (
        ColumnDistinctPercentChange1DayCheckSpec,
    )
    from ..models.column_distinct_percent_change_7_days_check_spec import (
        ColumnDistinctPercentChange7DaysCheckSpec,
    )
    from ..models.column_distinct_percent_change_30_days_check_spec import (
        ColumnDistinctPercentChange30DaysCheckSpec,
    )
    from ..models.column_distinct_percent_change_check_spec import (
        ColumnDistinctPercentChangeCheckSpec,
    )
    from ..models.column_distinct_percent_check_spec import (
        ColumnDistinctPercentCheckSpec,
    )
    from ..models.column_duplicate_count_check_spec import ColumnDuplicateCountCheckSpec
    from ..models.column_duplicate_percent_check_spec import (
        ColumnDuplicatePercentCheckSpec,
    )
    from ..models.column_uniqueness_daily_partitioned_checks_spec_custom_checks import (
        ColumnUniquenessDailyPartitionedChecksSpecCustomChecks,
    )


T = TypeVar("T", bound="ColumnUniquenessDailyPartitionedChecksSpec")


@_attrs_define
class ColumnUniquenessDailyPartitionedChecksSpec:
    """
    Attributes:
        custom_checks (Union[Unset, ColumnUniquenessDailyPartitionedChecksSpecCustomChecks]): Dictionary of additional
            custom checks within this category. The keys are check names defined in the definition section. The sensor
            parameters and rules should match the type of the configured sensor and rule for the custom check.
        daily_partition_distinct_count (Union[Unset, ColumnDistinctCountCheckSpec]):
        daily_partition_distinct_percent (Union[Unset, ColumnDistinctPercentCheckSpec]):
        daily_partition_duplicate_count (Union[Unset, ColumnDuplicateCountCheckSpec]):
        daily_partition_duplicate_percent (Union[Unset, ColumnDuplicatePercentCheckSpec]):
        daily_partition_distinct_count_anomaly (Union[Unset, ColumnDistinctCountAnomalyStationaryPartitionCheckSpec]):
        daily_partition_distinct_percent_anomaly (Union[Unset, ColumnDistinctPercentAnomalyStationaryCheckSpec]):
        daily_partition_distinct_count_change (Union[Unset, ColumnDistinctCountChangeCheckSpec]):
        daily_partition_distinct_percent_change (Union[Unset, ColumnDistinctPercentChangeCheckSpec]):
        daily_partition_distinct_count_change_1_day (Union[Unset, ColumnDistinctCountChange1DayCheckSpec]):
        daily_partition_distinct_count_change_7_days (Union[Unset, ColumnDistinctCountChange7DaysCheckSpec]):
        daily_partition_distinct_count_change_30_days (Union[Unset, ColumnDistinctCountChange30DaysCheckSpec]):
        daily_partition_distinct_percent_change_1_day (Union[Unset, ColumnDistinctPercentChange1DayCheckSpec]):
        daily_partition_distinct_percent_change_7_days (Union[Unset, ColumnDistinctPercentChange7DaysCheckSpec]):
        daily_partition_distinct_percent_change_30_days (Union[Unset, ColumnDistinctPercentChange30DaysCheckSpec]):
    """

    custom_checks: Union[
        Unset, "ColumnUniquenessDailyPartitionedChecksSpecCustomChecks"
    ] = UNSET
    daily_partition_distinct_count: Union[Unset, "ColumnDistinctCountCheckSpec"] = UNSET
    daily_partition_distinct_percent: Union[
        Unset, "ColumnDistinctPercentCheckSpec"
    ] = UNSET
    daily_partition_duplicate_count: Union[
        Unset, "ColumnDuplicateCountCheckSpec"
    ] = UNSET
    daily_partition_duplicate_percent: Union[
        Unset, "ColumnDuplicatePercentCheckSpec"
    ] = UNSET
    daily_partition_distinct_count_anomaly: Union[
        Unset, "ColumnDistinctCountAnomalyStationaryPartitionCheckSpec"
    ] = UNSET
    daily_partition_distinct_percent_anomaly: Union[
        Unset, "ColumnDistinctPercentAnomalyStationaryCheckSpec"
    ] = UNSET
    daily_partition_distinct_count_change: Union[
        Unset, "ColumnDistinctCountChangeCheckSpec"
    ] = UNSET
    daily_partition_distinct_percent_change: Union[
        Unset, "ColumnDistinctPercentChangeCheckSpec"
    ] = UNSET
    daily_partition_distinct_count_change_1_day: Union[
        Unset, "ColumnDistinctCountChange1DayCheckSpec"
    ] = UNSET
    daily_partition_distinct_count_change_7_days: Union[
        Unset, "ColumnDistinctCountChange7DaysCheckSpec"
    ] = UNSET
    daily_partition_distinct_count_change_30_days: Union[
        Unset, "ColumnDistinctCountChange30DaysCheckSpec"
    ] = UNSET
    daily_partition_distinct_percent_change_1_day: Union[
        Unset, "ColumnDistinctPercentChange1DayCheckSpec"
    ] = UNSET
    daily_partition_distinct_percent_change_7_days: Union[
        Unset, "ColumnDistinctPercentChange7DaysCheckSpec"
    ] = UNSET
    daily_partition_distinct_percent_change_30_days: Union[
        Unset, "ColumnDistinctPercentChange30DaysCheckSpec"
    ] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        custom_checks: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.custom_checks, Unset):
            custom_checks = self.custom_checks.to_dict()

        daily_partition_distinct_count: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.daily_partition_distinct_count, Unset):
            daily_partition_distinct_count = (
                self.daily_partition_distinct_count.to_dict()
            )

        daily_partition_distinct_percent: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.daily_partition_distinct_percent, Unset):
            daily_partition_distinct_percent = (
                self.daily_partition_distinct_percent.to_dict()
            )

        daily_partition_duplicate_count: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.daily_partition_duplicate_count, Unset):
            daily_partition_duplicate_count = (
                self.daily_partition_duplicate_count.to_dict()
            )

        daily_partition_duplicate_percent: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.daily_partition_duplicate_percent, Unset):
            daily_partition_duplicate_percent = (
                self.daily_partition_duplicate_percent.to_dict()
            )

        daily_partition_distinct_count_anomaly: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.daily_partition_distinct_count_anomaly, Unset):
            daily_partition_distinct_count_anomaly = (
                self.daily_partition_distinct_count_anomaly.to_dict()
            )

        daily_partition_distinct_percent_anomaly: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.daily_partition_distinct_percent_anomaly, Unset):
            daily_partition_distinct_percent_anomaly = (
                self.daily_partition_distinct_percent_anomaly.to_dict()
            )

        daily_partition_distinct_count_change: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.daily_partition_distinct_count_change, Unset):
            daily_partition_distinct_count_change = (
                self.daily_partition_distinct_count_change.to_dict()
            )

        daily_partition_distinct_percent_change: Union[Unset, Dict[str, Any]] = UNSET
        if not isinstance(self.daily_partition_distinct_percent_change, Unset):
            daily_partition_distinct_percent_change = (
                self.daily_partition_distinct_percent_change.to_dict()
            )

        daily_partition_distinct_count_change_1_day: Union[
            Unset, Dict[str, Any]
        ] = UNSET
        if not isinstance(self.daily_partition_distinct_count_change_1_day, Unset):
            daily_partition_distinct_count_change_1_day = (
                self.daily_partition_distinct_count_change_1_day.to_dict()
            )

        daily_partition_distinct_count_change_7_days: Union[
            Unset, Dict[str, Any]
        ] = UNSET
        if not isinstance(self.daily_partition_distinct_count_change_7_days, Unset):
            daily_partition_distinct_count_change_7_days = (
                self.daily_partition_distinct_count_change_7_days.to_dict()
            )

        daily_partition_distinct_count_change_30_days: Union[
            Unset, Dict[str, Any]
        ] = UNSET
        if not isinstance(self.daily_partition_distinct_count_change_30_days, Unset):
            daily_partition_distinct_count_change_30_days = (
                self.daily_partition_distinct_count_change_30_days.to_dict()
            )

        daily_partition_distinct_percent_change_1_day: Union[
            Unset, Dict[str, Any]
        ] = UNSET
        if not isinstance(self.daily_partition_distinct_percent_change_1_day, Unset):
            daily_partition_distinct_percent_change_1_day = (
                self.daily_partition_distinct_percent_change_1_day.to_dict()
            )

        daily_partition_distinct_percent_change_7_days: Union[
            Unset, Dict[str, Any]
        ] = UNSET
        if not isinstance(self.daily_partition_distinct_percent_change_7_days, Unset):
            daily_partition_distinct_percent_change_7_days = (
                self.daily_partition_distinct_percent_change_7_days.to_dict()
            )

        daily_partition_distinct_percent_change_30_days: Union[
            Unset, Dict[str, Any]
        ] = UNSET
        if not isinstance(self.daily_partition_distinct_percent_change_30_days, Unset):
            daily_partition_distinct_percent_change_30_days = (
                self.daily_partition_distinct_percent_change_30_days.to_dict()
            )

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if custom_checks is not UNSET:
            field_dict["custom_checks"] = custom_checks
        if daily_partition_distinct_count is not UNSET:
            field_dict[
                "daily_partition_distinct_count"
            ] = daily_partition_distinct_count
        if daily_partition_distinct_percent is not UNSET:
            field_dict[
                "daily_partition_distinct_percent"
            ] = daily_partition_distinct_percent
        if daily_partition_duplicate_count is not UNSET:
            field_dict[
                "daily_partition_duplicate_count"
            ] = daily_partition_duplicate_count
        if daily_partition_duplicate_percent is not UNSET:
            field_dict[
                "daily_partition_duplicate_percent"
            ] = daily_partition_duplicate_percent
        if daily_partition_distinct_count_anomaly is not UNSET:
            field_dict[
                "daily_partition_distinct_count_anomaly"
            ] = daily_partition_distinct_count_anomaly
        if daily_partition_distinct_percent_anomaly is not UNSET:
            field_dict[
                "daily_partition_distinct_percent_anomaly"
            ] = daily_partition_distinct_percent_anomaly
        if daily_partition_distinct_count_change is not UNSET:
            field_dict[
                "daily_partition_distinct_count_change"
            ] = daily_partition_distinct_count_change
        if daily_partition_distinct_percent_change is not UNSET:
            field_dict[
                "daily_partition_distinct_percent_change"
            ] = daily_partition_distinct_percent_change
        if daily_partition_distinct_count_change_1_day is not UNSET:
            field_dict[
                "daily_partition_distinct_count_change_1_day"
            ] = daily_partition_distinct_count_change_1_day
        if daily_partition_distinct_count_change_7_days is not UNSET:
            field_dict[
                "daily_partition_distinct_count_change_7_days"
            ] = daily_partition_distinct_count_change_7_days
        if daily_partition_distinct_count_change_30_days is not UNSET:
            field_dict[
                "daily_partition_distinct_count_change_30_days"
            ] = daily_partition_distinct_count_change_30_days
        if daily_partition_distinct_percent_change_1_day is not UNSET:
            field_dict[
                "daily_partition_distinct_percent_change_1_day"
            ] = daily_partition_distinct_percent_change_1_day
        if daily_partition_distinct_percent_change_7_days is not UNSET:
            field_dict[
                "daily_partition_distinct_percent_change_7_days"
            ] = daily_partition_distinct_percent_change_7_days
        if daily_partition_distinct_percent_change_30_days is not UNSET:
            field_dict[
                "daily_partition_distinct_percent_change_30_days"
            ] = daily_partition_distinct_percent_change_30_days

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        from ..models.column_distinct_count_anomaly_stationary_partition_check_spec import (
            ColumnDistinctCountAnomalyStationaryPartitionCheckSpec,
        )
        from ..models.column_distinct_count_change_1_day_check_spec import (
            ColumnDistinctCountChange1DayCheckSpec,
        )
        from ..models.column_distinct_count_change_7_days_check_spec import (
            ColumnDistinctCountChange7DaysCheckSpec,
        )
        from ..models.column_distinct_count_change_30_days_check_spec import (
            ColumnDistinctCountChange30DaysCheckSpec,
        )
        from ..models.column_distinct_count_change_check_spec import (
            ColumnDistinctCountChangeCheckSpec,
        )
        from ..models.column_distinct_count_check_spec import (
            ColumnDistinctCountCheckSpec,
        )
        from ..models.column_distinct_percent_anomaly_stationary_check_spec import (
            ColumnDistinctPercentAnomalyStationaryCheckSpec,
        )
        from ..models.column_distinct_percent_change_1_day_check_spec import (
            ColumnDistinctPercentChange1DayCheckSpec,
        )
        from ..models.column_distinct_percent_change_7_days_check_spec import (
            ColumnDistinctPercentChange7DaysCheckSpec,
        )
        from ..models.column_distinct_percent_change_30_days_check_spec import (
            ColumnDistinctPercentChange30DaysCheckSpec,
        )
        from ..models.column_distinct_percent_change_check_spec import (
            ColumnDistinctPercentChangeCheckSpec,
        )
        from ..models.column_distinct_percent_check_spec import (
            ColumnDistinctPercentCheckSpec,
        )
        from ..models.column_duplicate_count_check_spec import (
            ColumnDuplicateCountCheckSpec,
        )
        from ..models.column_duplicate_percent_check_spec import (
            ColumnDuplicatePercentCheckSpec,
        )
        from ..models.column_uniqueness_daily_partitioned_checks_spec_custom_checks import (
            ColumnUniquenessDailyPartitionedChecksSpecCustomChecks,
        )

        d = src_dict.copy()
        _custom_checks = d.pop("custom_checks", UNSET)
        custom_checks: Union[
            Unset, ColumnUniquenessDailyPartitionedChecksSpecCustomChecks
        ]
        if isinstance(_custom_checks, Unset):
            custom_checks = UNSET
        else:
            custom_checks = (
                ColumnUniquenessDailyPartitionedChecksSpecCustomChecks.from_dict(
                    _custom_checks
                )
            )

        _daily_partition_distinct_count = d.pop("daily_partition_distinct_count", UNSET)
        daily_partition_distinct_count: Union[Unset, ColumnDistinctCountCheckSpec]
        if isinstance(_daily_partition_distinct_count, Unset):
            daily_partition_distinct_count = UNSET
        else:
            daily_partition_distinct_count = ColumnDistinctCountCheckSpec.from_dict(
                _daily_partition_distinct_count
            )

        _daily_partition_distinct_percent = d.pop(
            "daily_partition_distinct_percent", UNSET
        )
        daily_partition_distinct_percent: Union[Unset, ColumnDistinctPercentCheckSpec]
        if isinstance(_daily_partition_distinct_percent, Unset):
            daily_partition_distinct_percent = UNSET
        else:
            daily_partition_distinct_percent = ColumnDistinctPercentCheckSpec.from_dict(
                _daily_partition_distinct_percent
            )

        _daily_partition_duplicate_count = d.pop(
            "daily_partition_duplicate_count", UNSET
        )
        daily_partition_duplicate_count: Union[Unset, ColumnDuplicateCountCheckSpec]
        if isinstance(_daily_partition_duplicate_count, Unset):
            daily_partition_duplicate_count = UNSET
        else:
            daily_partition_duplicate_count = ColumnDuplicateCountCheckSpec.from_dict(
                _daily_partition_duplicate_count
            )

        _daily_partition_duplicate_percent = d.pop(
            "daily_partition_duplicate_percent", UNSET
        )
        daily_partition_duplicate_percent: Union[Unset, ColumnDuplicatePercentCheckSpec]
        if isinstance(_daily_partition_duplicate_percent, Unset):
            daily_partition_duplicate_percent = UNSET
        else:
            daily_partition_duplicate_percent = (
                ColumnDuplicatePercentCheckSpec.from_dict(
                    _daily_partition_duplicate_percent
                )
            )

        _daily_partition_distinct_count_anomaly = d.pop(
            "daily_partition_distinct_count_anomaly", UNSET
        )
        daily_partition_distinct_count_anomaly: Union[
            Unset, ColumnDistinctCountAnomalyStationaryPartitionCheckSpec
        ]
        if isinstance(_daily_partition_distinct_count_anomaly, Unset):
            daily_partition_distinct_count_anomaly = UNSET
        else:
            daily_partition_distinct_count_anomaly = (
                ColumnDistinctCountAnomalyStationaryPartitionCheckSpec.from_dict(
                    _daily_partition_distinct_count_anomaly
                )
            )

        _daily_partition_distinct_percent_anomaly = d.pop(
            "daily_partition_distinct_percent_anomaly", UNSET
        )
        daily_partition_distinct_percent_anomaly: Union[
            Unset, ColumnDistinctPercentAnomalyStationaryCheckSpec
        ]
        if isinstance(_daily_partition_distinct_percent_anomaly, Unset):
            daily_partition_distinct_percent_anomaly = UNSET
        else:
            daily_partition_distinct_percent_anomaly = (
                ColumnDistinctPercentAnomalyStationaryCheckSpec.from_dict(
                    _daily_partition_distinct_percent_anomaly
                )
            )

        _daily_partition_distinct_count_change = d.pop(
            "daily_partition_distinct_count_change", UNSET
        )
        daily_partition_distinct_count_change: Union[
            Unset, ColumnDistinctCountChangeCheckSpec
        ]
        if isinstance(_daily_partition_distinct_count_change, Unset):
            daily_partition_distinct_count_change = UNSET
        else:
            daily_partition_distinct_count_change = (
                ColumnDistinctCountChangeCheckSpec.from_dict(
                    _daily_partition_distinct_count_change
                )
            )

        _daily_partition_distinct_percent_change = d.pop(
            "daily_partition_distinct_percent_change", UNSET
        )
        daily_partition_distinct_percent_change: Union[
            Unset, ColumnDistinctPercentChangeCheckSpec
        ]
        if isinstance(_daily_partition_distinct_percent_change, Unset):
            daily_partition_distinct_percent_change = UNSET
        else:
            daily_partition_distinct_percent_change = (
                ColumnDistinctPercentChangeCheckSpec.from_dict(
                    _daily_partition_distinct_percent_change
                )
            )

        _daily_partition_distinct_count_change_1_day = d.pop(
            "daily_partition_distinct_count_change_1_day", UNSET
        )
        daily_partition_distinct_count_change_1_day: Union[
            Unset, ColumnDistinctCountChange1DayCheckSpec
        ]
        if isinstance(_daily_partition_distinct_count_change_1_day, Unset):
            daily_partition_distinct_count_change_1_day = UNSET
        else:
            daily_partition_distinct_count_change_1_day = (
                ColumnDistinctCountChange1DayCheckSpec.from_dict(
                    _daily_partition_distinct_count_change_1_day
                )
            )

        _daily_partition_distinct_count_change_7_days = d.pop(
            "daily_partition_distinct_count_change_7_days", UNSET
        )
        daily_partition_distinct_count_change_7_days: Union[
            Unset, ColumnDistinctCountChange7DaysCheckSpec
        ]
        if isinstance(_daily_partition_distinct_count_change_7_days, Unset):
            daily_partition_distinct_count_change_7_days = UNSET
        else:
            daily_partition_distinct_count_change_7_days = (
                ColumnDistinctCountChange7DaysCheckSpec.from_dict(
                    _daily_partition_distinct_count_change_7_days
                )
            )

        _daily_partition_distinct_count_change_30_days = d.pop(
            "daily_partition_distinct_count_change_30_days", UNSET
        )
        daily_partition_distinct_count_change_30_days: Union[
            Unset, ColumnDistinctCountChange30DaysCheckSpec
        ]
        if isinstance(_daily_partition_distinct_count_change_30_days, Unset):
            daily_partition_distinct_count_change_30_days = UNSET
        else:
            daily_partition_distinct_count_change_30_days = (
                ColumnDistinctCountChange30DaysCheckSpec.from_dict(
                    _daily_partition_distinct_count_change_30_days
                )
            )

        _daily_partition_distinct_percent_change_1_day = d.pop(
            "daily_partition_distinct_percent_change_1_day", UNSET
        )
        daily_partition_distinct_percent_change_1_day: Union[
            Unset, ColumnDistinctPercentChange1DayCheckSpec
        ]
        if isinstance(_daily_partition_distinct_percent_change_1_day, Unset):
            daily_partition_distinct_percent_change_1_day = UNSET
        else:
            daily_partition_distinct_percent_change_1_day = (
                ColumnDistinctPercentChange1DayCheckSpec.from_dict(
                    _daily_partition_distinct_percent_change_1_day
                )
            )

        _daily_partition_distinct_percent_change_7_days = d.pop(
            "daily_partition_distinct_percent_change_7_days", UNSET
        )
        daily_partition_distinct_percent_change_7_days: Union[
            Unset, ColumnDistinctPercentChange7DaysCheckSpec
        ]
        if isinstance(_daily_partition_distinct_percent_change_7_days, Unset):
            daily_partition_distinct_percent_change_7_days = UNSET
        else:
            daily_partition_distinct_percent_change_7_days = (
                ColumnDistinctPercentChange7DaysCheckSpec.from_dict(
                    _daily_partition_distinct_percent_change_7_days
                )
            )

        _daily_partition_distinct_percent_change_30_days = d.pop(
            "daily_partition_distinct_percent_change_30_days", UNSET
        )
        daily_partition_distinct_percent_change_30_days: Union[
            Unset, ColumnDistinctPercentChange30DaysCheckSpec
        ]
        if isinstance(_daily_partition_distinct_percent_change_30_days, Unset):
            daily_partition_distinct_percent_change_30_days = UNSET
        else:
            daily_partition_distinct_percent_change_30_days = (
                ColumnDistinctPercentChange30DaysCheckSpec.from_dict(
                    _daily_partition_distinct_percent_change_30_days
                )
            )

        column_uniqueness_daily_partitioned_checks_spec = cls(
            custom_checks=custom_checks,
            daily_partition_distinct_count=daily_partition_distinct_count,
            daily_partition_distinct_percent=daily_partition_distinct_percent,
            daily_partition_duplicate_count=daily_partition_duplicate_count,
            daily_partition_duplicate_percent=daily_partition_duplicate_percent,
            daily_partition_distinct_count_anomaly=daily_partition_distinct_count_anomaly,
            daily_partition_distinct_percent_anomaly=daily_partition_distinct_percent_anomaly,
            daily_partition_distinct_count_change=daily_partition_distinct_count_change,
            daily_partition_distinct_percent_change=daily_partition_distinct_percent_change,
            daily_partition_distinct_count_change_1_day=daily_partition_distinct_count_change_1_day,
            daily_partition_distinct_count_change_7_days=daily_partition_distinct_count_change_7_days,
            daily_partition_distinct_count_change_30_days=daily_partition_distinct_count_change_30_days,
            daily_partition_distinct_percent_change_1_day=daily_partition_distinct_percent_change_1_day,
            daily_partition_distinct_percent_change_7_days=daily_partition_distinct_percent_change_7_days,
            daily_partition_distinct_percent_change_30_days=daily_partition_distinct_percent_change_30_days,
        )

        column_uniqueness_daily_partitioned_checks_spec.additional_properties = d
        return column_uniqueness_daily_partitioned_checks_spec

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
